import es, cfglib, cmdlib
import Printer
reload(Printer)
from AdList import AdList

class Config:

	def __init__(self,file,info):
		self.config = cfglib.AddonCFG(es.getAddonPath(info.basename)+'/'+file)
		self.adlists = [
			AdList(Printer.CenterPrinter,'center','Center of the screen',150),
			AdList(Printer.TextAreaPrinter,'textarea','Chat Area messages',25),
			AdList(Printer.TopTexPrinter,'toptext','Top Left black box',90),
			AdList(Printer.HUDHintPrinter,'bottomcenter','Center Bottom HUD',120),
			AdList(Printer.ConsolePrinter,'console','Console spammer',100),
		]
		self.configure()
	
	def readCVar(self,cvar,default,description):
		cvar = 'adverts_'+cvar
		description = '|----- '+description
		return self.config.cvar(cvar,default,description)

	def readNumber(self,cvar,default,description):
		string = self.readCVar(cvar,default,description)
		number = default
		try:
			number = int(string)
		except ValueError:
			es.dbgmsg(0,'Warning: cvar '+cvar+' not a number. Using default:',default)
		return number

	def addToList(self,args,list):
		if len(args) != 1:
			es.dbgmsg(0,'Warning: '+list.addcmd+' list adder expects 1 argument. Given: '+len(args))
		else:
			list.add(args[0])
	
	def addCommand(self,list):
		cmdlib.registerServerCommand(
				list.addcmd,
				(lambda args:self.addToList(args,list)),
				'Adds the given string to the list of ads of '+list.name)

	def configure(self):

		self.config.text("******************************")
		self.config.text("|  Bennit's Advert Settings  |")
		self.config.text("******************************")
		
		for ads in self.adlists:
			self.config.text('|-- '+ads.description)
			self.config.text('|---- List all '+ads.name+' ads like this:')
			self.config.text('|---- '+ads.addcmd+' "<ad line here>"')
			self.addCommand(ads)
			self.config.text(ads.addcmd+' "Adverts by Bennit^"')
			self.config.text(ads.addcmd+' "This server is running {Game}."')
			self.config.text(ads.addcmd+' "{PLAYERS}/{MAXPLAYERS} slots filled. T({T})/CT({CT})/SPEC({SPEC})/BOT({BOTS})"')
			self.config.text('|---- Static settings')
			ads.interval = self.readNumber(
					ads.name+'_interval',
					ads.interval,
					'Interval of showing this type of message (in seconds)')
			self.config.text('|-----------------------------------------')
			self.config.text('',None)
		
		self.config.write()
		return self
